//===============================================================================
// Program : comm_groups.cpp
// Purpose : Illustrates managing communication groups. This program is designed
//           to run ot 4 MPI processes
//
//Compile : mpicxx -o comm_groups.x comm_groups.cpp -O2
//===============================================================================
#include <iostream>
#include <mpi.h>
#include <new>
using namespace std;

int main(int argc, char** argv){
  int i;
  int iproc;
  int nproc;
  int new_iproc;
  int new_nproc;
  int ikey;
  int icolor;
  MPI_Comm newcomm;
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&iproc);
  MPI_Comm_size(MPI_COMM_WORLD,&nproc);
  if ( iproc == 0 ){
    icolor = 1;
    ikey = 2;
  }
  else if ( iproc == 1 ){
    icolor = 1;
    ikey = 1;
  }
  else if ( iproc == 2 ){
    icolor = 2;
    ikey = 1;
  }
  else if ( iproc == 3 ){
    icolor = 2;
    ikey = 2;
  }
  MPI_Comm_split(MPI_COMM_WORLD, icolor, ikey, &newcomm);
  MPI_Comm_rank(newcomm, &new_iproc);
  MPI_Comm_size(newcomm, &new_nproc);
  if ( icolor == 1 ){
    if ( new_iproc == 0 )
      cout << "icolor = " << icolor << endl;
    cout << "new_iproc = " << new_iproc << '\t' << "iproc = " << iproc << endl;
  }
  else if ( icolor == 2 ){
    if ( new_iproc == 0 )
      cout << "icolor = " << icolor << endl;
    cout << "new_iproc = " << new_iproc << '\t' << "iproc = " << iproc << endl;
  }
  MPI_Finalize();
  return 0;
}
