!===============================================================================
! Program : psum2.f90
! Purpose : Sums up elemnts of an array, a(n), using
!           cyclic distribution
!
! Compile : mpif90 -o psum2.x psum2.f90 -O2
!===============================================================================
program main
  implicit none
  include 'mpif.h'
  integer(4), parameter :: n = 1000
  integer(4) :: a(n)
  integer(4) :: i
  integer(4) :: sum
  integer(4) :: ssum
  integer(4) :: ierr
  integer(4) :: iproc
  integer(4) :: nproc
  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nproc, ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, iproc, ierr)
  do i = 1 + iproc, n, nproc
     a(i) = i
  end do
  sum = 0.0
  do i = 1 + iproc, n, nproc
     sum = sum + a(i)
  end do
  call MPI_REDUCE(sum, ssum, 1, MPI_INTEGER,MPI_SUM, 0,MPI_COMM_WORLD, ierr)
  sum = ssum
  if ( iproc == 0 ) write(6,*)'sum =', sum
  call MPI_FINALIZE(ierr)
end program main
